from datetime import datetime, timedelta
from time import sleep
import pytz
import json
import requests
import sys

def sortevents(leaguedata, league):

    games = []
    haslive = False

    for event in leaguedata['events']:

        event_desc = event['status']['type']['shortDetail']  # use this to display time and quarter on ticker
        event_date = event['date'].split('T')[0]
        event_liveOrNot = event['status']['type']['state'] # use this to determine if game has ended or not
        if event_liveOrNot == 'in':
            haslive = True
        has_live = 'has_live'
        no_upcoming = 'no_upcoming'

        for home_away in event['competitions']:
            for home_away2 in home_away['competitors']:
                if home_away2['homeAway'] == 'away':
                    if home_away2['team']['displayName'] == 'Washington Commanders':
                        away_team = 'Washington'
                    else:
                        away_team = home_away2['team']['displayName']
                    away_score = home_away2['score']
                else:
                    if home_away2['team']['displayName'] == 'Washington Commanders':
                        home_team = 'Washington'
                    else:
                        home_team = home_away2['team']['displayName']
                    home_score = home_away2['score']

        if datetime.now(pytz.utc).strftime("%Y-%m-%d") == event['date'].split('T')[0] or event['date'].split('T')[0] <= (datetime.strptime(datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ"), "%Y-%m-%dT%H:%MZ") + timedelta(days=1)).strftime("%Y-%m-%dT%H:%MZ").split('T')[0]:
            games.append({
                'home_team': home_team,
                'home_score': home_score,
                'away_team': away_team,
                'away_score': away_score,
                'time': event_desc,
                'date': event_date,
                'isLive': event_liveOrNot
            })
    return games, haslive, has_live, no_upcoming


f = open('csv/live_nhl.json', 'r')
all_settings = json.load(f)
f.close()

nhl_url = "https://site.api.espn.com/apis/site/v2/sports/hockey/nhl/scoreboard"

time_now = datetime.now(pytz.utc)
time_now2 = time_now.strftime("%Y-%m-%dT%H:%MZ")

NHL_live_now = False
NHL_games_today = False
NHL_events = []
NHL_fifteenmin = False
games_happened = False


try:
    nhl_response = requests.get(nhl_url)
    nhl_data = nhl_response.json()
except:
    sleep(120)
    nhl_response = requests.get(nhl_url)
    nhl_data = nhl_response.json()

for event in nhl_data['events']:
    if event['status']['type']['state'] == 'in':
        NHL_live_now = True
    if time_now2.split('T')[0] <= event['date'].split('T')[0] and event['date'].split('T')[0] <= (datetime.strptime(time_now2, "%Y-%m-%dT%H:%MZ") + timedelta(days=1)).strftime("%Y-%m-%dT%H:%MZ").split('T')[0]:
        NHL_events.append(event['date'])
        NHL_games_today = True
        if NHL_live_now is False and ((datetime.strptime(event['date'], "%Y-%m-%dT%H:%MZ") + timedelta(minutes=20)).strftime("%Y-%m-%dT%H:%MZ") >= datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ")) and (event['date'] <= datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ")):
            NHL_fifteenmin = True


while True:
    f = open('csv/live_nhl.json', 'r')
    all_settings = json.load(f)
    f.close()

    if NHL_live_now:
        try:
            nhl_response = requests.get(nhl_url)
            nhl_data = nhl_response.json()
            nhl_sorted = sortevents(nhl_data, 'NHL')
            all_settings['leagues']['NHL'] = nhl_sorted
            games_happened = True

            if nhl_sorted[1]:
                NHL_live_now = True

            else:
                NHL_live_now = False           
 
            f = open('csv/live_nhl.json', 'w+')
            json.dump(all_settings, f)
            f.close()

            sleep(120)

        except:
            sleep(120)

    elif NHL_fifteenmin:
        for _ in range (10):
            try:
                nhl_response = requests.get(nhl_url)
                nhl_data = nhl_response.json()
                nhl_sorted = sortevents(nhl_data, 'NHL')
                all_settings['leagues']['NHL'] = nhl_sorted

                f = open('csv/live_nhl.json', 'w+')
                json.dump(all_settings, f)
                f.close()
                sleep(120)     

            except:
                sleep(120)

        if nhl_sorted[1]:
            NHL_live_now = True
            NHL_fifteenmin = False
            games_happened = True
      
        else:
            NHL_live_now = False
            NHL_fifteenmin = False

    else:
        NHL_events2 = []

        try:
            for event in NHL_events:
                if event >= datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ"):
                    NHL_events2.append(event)
                    NHL_games_today = True
            next_NHL = min(NHL_events2)
            d = datetime.strptime(next_NHL, "%Y-%m-%dT%H:%MZ")
            NHL_time_left = (d - (datetime.strptime(datetime.now(pytz.utc).strftime("%Y-%m-%dT%H:%MZ"), "%Y-%m-%dT%H:%MZ"))).total_seconds()
            all_settings['leagues']['NHL'][3] = next_NHL

            f = open('csv/live_nhl.json', 'w+')
            json.dump(all_settings, f)
            f.close() 

        except:
            NHL_games_today = False
            next_NHL = []
            all_settings['leagues']['NHL'][3] = 'no_upcoming'

            f = open('csv/live_nhl.json', 'w+')
            json.dump(all_settings, f)
            f.close() 

            pass    

        if NHL_games_today:

            sleep(NHL_time_left)
            NHL_fifteenmin = True


    if NHL_live_now is False and NHL_games_today is False and games_happened is True:
        sleep(7200)

        all_settings['leagues']['NHL'][2] = 'no_live'
        all_settings['leagues']['NHL'][3] = 'no_upcoming'

        f = open('csv/live_nhl.json', 'w+')
        json.dump(all_settings, f)
        f.close()

        break


    if NHL_live_now is False and NHL_games_today is False and games_happened is False:

        all_settings['leagues']['NHL'][2] = 'no_live'
        all_settings['leagues']['NHL'][3] = 'no_upcoming'

        f = open('csv/live_nhl.json', 'w+')
        json.dump(all_settings, f)
        f.close()

        break
